/* Xhedgehog 0.0.5 - Character Module */
#include "xhbasic.h"
#include "shield.h"
#include "ring.h"
#include "bring.h"
#include "spring.h"
#include "Stand.xpm"
#include "Step.xpm"
#include "Spin.xpm"
#include "Run.xpm"
#include "Slide.xpm"
#include "Fall.xpm"
#include "Squat.xpm"
#include "Lookup.xpm"
#include "Lookup2.xpm"
#include "Juice.xpm"
#include "Stand-l.xpm"
#include "Step-l.xpm"
#include "Spin-l.xpm"
#include "Run-l.xpm"
#include "Slide-l.xpm"
#include "Fall-l.xpm"
#include "Squat-l.xpm"
#include "Lookup-l.xpm"
#include "Lookup2-l.xpm"
#include "Juice-l.xpm"
Pixmap Stand_pxm[2] = {0,0};
Pixmap Step_pxm[2],Spin_pxm[2],Run_pxm[2],Slide_pxm[2],
  Stand_mask[2],Step_mask[2],Spin_mask[2],Run_mask[2],Slide_mask[2],
  Fall_pxm[2],Fall_mask[2],Squat_pxm[2],Squat_mask[2],Lookup_pxm[2],
  Lookup_mask[2],Lookup2_pxm[2],Lookup2_mask[2],Juice_pxm[2],Juice_mask[2];


/* This function is exported to give dynamically linked programs an interface
to create the sprite. */
extern "C" {
  Sonic *CreateCharacter(XhedgehogWin *sw,float _x,float _y) {
    return new Sonic(sw,_x,_y);
  }
}

void Sonic::MoveSprite(float newx,float newy) {
  char d[80];
  //  //Print out our hero's current position on the ncurses console.
  // sprintf(d,"Pos:%d,%d      ",(int)(XPos()),(int)(YPos()));
  //mvaddstr(1,0,d);
  //refresh();

  //Get Sonic's location in the tile map, and the type of tile he's standing
  //on.
  float tx = newx + (cx / 2); float ty = newy + cy;
  int f,ts;
  if(((ts = GetTileStatus
	  (((XhedgehogWin *)host)->tspr->FetchTile
	   ((int)newx + (cx),(int)newy + (cy / 2)))) 
	 & 0x800) && ts != -1) {
    int nx = ((int)newx + (cx));
    newx = nx - (nx % TILE_SIZE) - cx;
    vel = 0;
  }
  
  if(((ts = GetTileStatus
	  (((XhedgehogWin *)host)->tspr->FetchTile
	   ((int)newx,(int)newy + (cy / 2)))) & 0x800) && ts != -1) {
    int nx = (int)newx + TILE_SIZE;
    newx = nx - (nx % TILE_SIZE);
    vel = 0;
  }
  
  while(((ts = GetTileStatus
	  (((XhedgehogWin *)host)->tspr->FetchTile
	   ((int)newx + (cx / 2),(int)newy))) & 0x800) && ts != -1) {
    int ny = (int)newy + TILE_SIZE;
    newy = ny - (ny % TILE_SIZE);
    if(GetFlag(JUMPFLAG)) {
      vy = 0;
    }
  }
  f = ((XhedgehogWin *)host)->tspr->FetchTile((int)tx,(int)ty);
  //If we're standing on solid ground...
  if((ts = GetTileStatus(f)) != -1) {
    slope = (ts & 0xff);
    //If we're falling, stop.
    if(vy > 0) {
      vy = 0;
      //Go into Walk Mode.
      if(!GetFlag(WALKFLAG)) {      
	ClearFlag(HITFLAG);
	if(!GetKeyStatus(DOWNKEY)) {
	  if(vx == 0) SetStandShape();
	  else {
	    if(_abs(vx) >= 8) {
	      SetRunShape();
	    }
	    else {
	      SetWalkShape();
	    }
	  }
	  ClearFlag(ROLLFLAG);
	}
	ClearFlag(JUMPFLAG);
	SetFlag(WALKFLAG);
	if(!GetKeyStatus(LEFTKEY | RIGHTKEY | DOWNKEY)) {
	  if(dir) {
	    accel = 2;
	  }
	  else {
	    accel = -2;
	  }
	}	    
      }
    }
    newy = ty - cy - ((int)ty % TILE_SIZE);
    switch(slope) {
    case 1:
      newy += 8;
      newy -= ((int)tx % TILE_SIZE) / 2;
      break;
    case 15:
      newy += ((int)tx % TILE_SIZE) / 2;
      break;
    }
    if(ts & 0x100) {
      newy += 8;
    }
    if(ts & 0x200) {
      newy -= 16;
    }
  }
  else {
    if(GetFlag(WALKFLAG)) {
      if(LastSurf != NULL) {
	if(!SpriteHitTest2(LastSurf)) {
	  LastSurf = NULL;
	}
      }
      if(LastSurf == NULL) {
	ClearFlag(WALKFLAG);
	SetFlag(JUMPFLAG);
	vy = 0;
      }
    }
  }
  __MoveSprite(newx,newy);
  //If Sonic is in the air, make him fall (gravitational acceleration).
  if(GetFlag(JUMPFLAG)) {
    if(vy < 16) {
      vy += 0.5;
    }
  }
  //Make Sonic accelerate into a run for as long as the key is held down.
  //He moves at constant speed when speed >= maxvel.
  if(GetFlag(WALKFLAG)) {
    if(GetFlag(ROLLFLAG)) {
      maxvel = 25;
    }
    else {
      maxvel = 10;
    }
    float tvx = _abs(vel);
    float tvx2 = vel;
    if(GetFlag(SLIDEFLAG)) {
      switch(dir) {
      case 0:
	if(vel <= 0) {
	  if(GetKeyStatus(LEFTKEY)) {
	    accel = -1.0;
	    dir = 1;
	    SetWalkShape();
	  }
	  else {
	    accel = 0;
	    SetStandShape();
	  }
	  ClearFlag(ROLLFLAG);
	  ClearFlag(SLIDEFLAG);
	}
	break;
      case 1:
	if(vel >= 0) {
	  if(GetKeyStatus(RIGHTKEY)) {
	    accel = 1.0;
	    dir = 0;
	    SetWalkShape();
	  }
	  else {
	    accel = 0;
	    SetStandShape();
	  }
	  ClearFlag(ROLLFLAG);
	  ClearFlag(SLIDEFLAG);
	}
	break;
      }
      vel += accel;
    }
    else {
      if(frame % 4 == 0) {
	if(_abs(vel) <= maxvel) {
	  vel += accel;
	}
	else {
	  vel = maxvel * sgn(vel);
	  accel = 0;
	}
	if(!GetFlag(ROLLFLAG)) {
	  if((_abs(vel) >= 7) && (pxm != Run_pxm[dir])) 
	    SetRunShape();
	  else
	    if((_abs(vel) < 7) && (pxm != Step_pxm[dir]) && (_abs(vel) > 0))
	      SetWalkShape();
	}
      }
      if(vel < 0 && dir == 0) {
	vel = 0; accel = 0; 
	SetStandShape();
	ClearFlag(ROLLFLAG);
      }
      if(vel > 0 && dir == 1) {
	vel = 0;
	accel = 0;
	SetStandShape();
	ClearFlag(ROLLFLAG);
      }
    }
    switch(slope) {
    case 0:
      vx = vel;
      break;
    case 1:
      vx = vel * 0.894;
      vy = -(vel * 0.447);
      break;
    case 15:
      vx = vel * 0.894;
      vy = vel * 0.447;
      break;
    }
  }
  //Path to take if we are not standing (i.e., in the air).
  else {
    if(frame % 4 == 0) {
      float tvx = _abs(vel);
      float tvx2 = vel;
      if(tvx < maxvel) {
	vel += accel;
      }
      else {
	vel = maxvel * sgn(vel);
      }
      vx = vel;
    }
    if(dir == 0 && vel < 0 &&
       !GetKeyStatus(LEFTKEY | RIGHTKEY)) {
      vel = 0; accel = 0;
    }
    if(dir == 1 && vel > 0 &&
       !GetKeyStatus(LEFTKEY | RIGHTKEY)) {
      vel = 0; accel = 0;
    }
  }
  
}

//Initialize the Sonic object.
Sonic::Sonic(XhedgehogWin *sw,float _x,float _y)
  : MultiframeSprite(sw,_x,_y,stand_xpm,1,2) {
    //Clear all our flags.
    flags = 0; keys = 0;
    accel = 0;
    dir = 0;
    vel = 0; slope = 0;
    rings = 0;
    auto_animate = True;
    auto_hittest = True;
    sh = NULL;
    LastSurf = NULL;
    maxvel = 10;
    //Initialize our pixmaps the first time Sonic is loaded.
    if(Stand_pxm[0] == 0) {
      sw->LoadPixmap(stand_xpm,&(Stand_pxm[0]),&(Stand_mask[0]));
      sw->LoadPixmap(step_xpm,&(Step_pxm[0]),&(Step_mask[0]));
      sw->LoadPixmap(spin_xpm,&(Spin_pxm[0]),&(Spin_mask[0]));
      sw->LoadPixmap(run_xpm,&(Run_pxm[0]),&(Run_mask[0]));
      sw->LoadPixmap(slide_xpm,&(Slide_pxm[0]),&(Slide_mask[0]));
      sw->LoadPixmap(fall_xpm,&(Fall_pxm[0]),&(Fall_mask[0]));
      sw->LoadPixmap(squat_xpm,&(Squat_pxm[0]),&(Squat_mask[0]));
      sw->LoadPixmap(lookup_xpm,&(Lookup_pxm[0]),&(Lookup_mask[0]));
      sw->LoadPixmap(lookup2_xpm,&(Lookup2_pxm[0]),&(Lookup2_mask[0]));
      sw->LoadPixmap(juice_xpm,&(Juice_pxm[0]),&(Juice_mask[0]));
      sw->LoadPixmap(stand_l_xpm,&(Stand_pxm[1]),&(Stand_mask[1]));
      sw->LoadPixmap(step_l_xpm,&(Step_pxm[1]),&(Step_mask[1]));
      sw->LoadPixmap(spin_l_xpm,&(Spin_pxm[1]),&(Spin_mask[1]));
      sw->LoadPixmap(run_l_xpm,&(Run_pxm[1]),&(Run_mask[1]));
      sw->LoadPixmap(slide_l_xpm,&(Slide_pxm[1]),&(Slide_mask[1]));
      sw->LoadPixmap(fall_l_xpm,&(Fall_pxm[1]),&(Fall_mask[1]));
      sw->LoadPixmap(squat_l_xpm,&(Squat_pxm[1]),&(Squat_mask[1]));
      sw->LoadPixmap(lookup_l_xpm,&(Lookup_pxm[1]),&(Lookup_mask[1]));
      sw->LoadPixmap(lookup2_l_xpm,&(Lookup2_pxm[1]),&(Lookup2_mask[1]));
      sw->LoadPixmap(juice_l_xpm,&(Juice_pxm[1]),&(Juice_mask[1]));
    }
    InitializePosition();
}

void Sonic::OnHitTest(Sprite *s) {
  Enemy *e;
  if((e = dynamic_cast<Enemy *>(s)) != NULL) {
    if(!GetFlag(ROLLFLAG)) {
      if(!GetFlag(HITFLAG)) {
	EnemyHit();
      }
    }
    else {
      e->Destroy();
      Bounce();
    }
  }
  Spring *sp;
  if((sp = dynamic_cast<Spring *>(s)) != NULL) {
    if(SpriteHitTest2(sp)) {
      if((YPos() + YSize() < sp->YPos() + (sp->YSize() / 2)) &&
	 (YVel() > 0)) {
	vy = -15;
	ClearFlag(WALKFLAG);
	ClearFlag(ROLLFLAG);
	SetFlag(JUMPFLAG);
	SetLookup2Shape();
	if(sp->ct <= 0) {
	  sp->Activate();
	}
      }
    }
  }
    
}

void Sonic::EnemyHit() {
  SetFlag(JUMPFLAG);
  ClearFlag(WALKFLAG);
  ClearFlag(ROLLFLAG);
  SetFlag(HITFLAG);
  SetFallShape();
  ((XhedgehogWin *)host)->SoundSrvPlay(3);
  vy = -8;
  vel = -vel; accel = 0;
  int r = (rings > 16 ? 16 : rings);
  if(sh == NULL) {
    for(int i=0;i < r;i++) {
      new BouncingRing((XhedgehogWin *)host,x + 16,y + 16,i);
    }
    rings = 0;
    ((XhedgehogWin *)host)->SoundSrvPlay(2);
  }
  else {
    DisableShield();
  }
}

//Set Sonic's standing position.
void Sonic::SetStandShape() {
  int tcy = cy;
  int tcx = cx;
  ChangeSpriteShape(Stand_pxm[dir],Stand_mask[dir]);
  SetMaxFrames(1);
  SetFrame(0);
  y += tcy - cy;
  x += (tcx - cx) / 2;
}

void Sonic::SetWalkShape() {
  int tcy = cy;
  int tcx = cx;
  ChangeSpriteShape(Step_pxm[dir],Step_mask[dir]);
  SetMaxFrames(8);
  SetFrame(0);
  y += tcy - cy;
  x += (tcx - cx) / 2;
}

void Sonic::SetSpinShape() {
  int tcy = cy;
  int tcx = cx;
  ChangeSpriteShape(Spin_pxm[dir],Spin_mask[dir]);
  SetMaxFrames(5);
  SetFrame(0);
  y += tcy - cy;
  x += (tcx - cx) / 2;
}

void Sonic::SetRunShape() {
  int tcy = cy;
  int tcx = cx;
  ChangeSpriteShape(Run_pxm[dir],Run_mask[dir]);
  SetMaxFrames(4);
  SetFrame(0);
  y += tcy - cy;
  x += (tcx - cx) / 2;
}

void Sonic::SetSlideShape() {
  int tcy = cy;
  int tcx = cx;
  ChangeSpriteShape(Slide_pxm[dir],Slide_mask[dir]);
  SetMaxFrames(1);
  SetFrame(0);
  y += tcy - cy;
  x += (tcx - cx) / 2;
}

void Sonic::SetFallShape() {
  int tcy = cy;
  int tcx = cx;
  ChangeSpriteShape(Fall_pxm[dir],Fall_mask[dir]);
  SetMaxFrames(1);
  SetFrame(0);
  y += tcy - cy;
  x += (tcx - cx) / 2;
}

void Sonic::SetSquatShape() {
  int tcy = cy;
  int tcx = cx;
  ChangeSpriteShape(Squat_pxm[dir],Squat_mask[dir]);
  SetMaxFrames(1);
  SetFrame(0);
  y += tcy - cy;
  x += (tcx - cx) / 2;
}

void Sonic::SetLookupShape() {
  int tcy = cy;
  int tcx = cx;
  ChangeSpriteShape(Lookup_pxm[dir],Lookup_mask[dir]);
  SetMaxFrames(1);
  SetFrame(0);
  y += tcy - cy;
  x += (tcx - cx) / 2;
}

void Sonic::SetLookup2Shape() {
  int tcy = cy;
  int tcx = cx;
  ChangeSpriteShape(Lookup2_pxm[dir],Lookup2_mask[dir]);
  SetMaxFrames(1);
  SetFrame(0);
  y += tcy - cy;
  x += (tcx - cx) / 2;
}

void Sonic::SetJuiceShape() {
  int tcy = cy;
  int tcx = cx;
  ChangeSpriteShape(Juice_pxm[dir],Juice_mask[dir]);
  SetMaxFrames(5);
  SetFrame(0);
  y += tcy - cy;
  x += (tcx - cx) / 2;
}

void Sonic::IncreaseRings() {
  rings++;
  ((XhedgehogWin *)host)->SoundSrvPlay(1);
}

void Sonic::IncreaseRingsByTen() {
  rings += 10;
  ((XhedgehogWin *)host)->SoundSrvPlay(1);
}



void Sonic::InitializePosition() {
  TileSprite *tsp = ((XhedgehogWin *)host)->tspr;
  int sx = tsp->XSize();
  int sy = tsp->YSize();
  int tx = x - (sx / 2);
  int ty = y - (sy / 2);
  int ux = (tsp->TMapWidth() - 2) * TILE_SIZE;
  int uy = (tsp->TMapHeight() - 2) * TILE_SIZE;
  tsp->MoveSprite((tx < 0 ? 0 : 
		   (tx + sx > ux ? ux - sx : tx)),
		  (ty < 0 ? 0 :
		   (ty + sy > uy ? uy - sy : ty)));
}

int Sonic::SpriteHitTest2(Sprite *s) {
  int tcx = cx;
  cx /= 2;
  float tx = x;
  if(s->XPos() < tx) {
    x += cx;
  }
  int f = SpriteHitTest(s);
  x = tx;
  cx = tcx;
  return f;
}

void Sonic::StandSurf(Sprite *s) {
  if(SpriteHitTest2(s)) {
    SetFlag(WALKFLAG);
    ClearFlag(JUMPFLAG);
    ClearFlag(ROLLFLAG);
    if(LastSurf != s) {
      SetStandShape();
      LastSurf = s;
      y = s->YPos() + 2 - cy;
      vy = 0;
    }
    slope = 0;
  }
}

void Sonic::Bounce() {
  if(GetFlag(JUMPFLAG) && vy > 0) {
    if(GetKeyStatus(JUMPKEY)) {
      vy = -vy;
    }
    else {
      vy = -6;
    }
  }
}

void Sonic::EnableShield() {
  if(sh == NULL) {
    sh = new Shield(this);
    ((XhedgehogWin *)host)->SoundSrvPlay(4);
  }
}

void Sonic::DisableShield() {
  if(sh != NULL) {
    sh->Nuke();
  }
  sh = NULL;
}

//This locks Sonic's motions and the screen scrolling.
void Sonic::__MoveSprite(float newx,float newy) {
  float tx = x;
  float ty = y;
  float tvx = 0,tvy = 0;
  XhedgehogWin *w = (XhedgehogWin *)host;
  if(newx < 0) {
    newx = 0;
    vel = 0;
  }
  if((newx + cx) > (w->tspr->TMapWidth() - 2) * TILE_SIZE) {
    newx = ((w->tspr->TMapWidth() - 2) * TILE_SIZE) - cx;
    vel = 0;
  }
  MultiframeSprite::MoveSprite(newx,newy);
  if(
     (
      (
       (w->tspr->XPos() <= (w->tspr->TMapWidth() - 2) * TILE_SIZE
	- w->XSize()) &&
       (newx - w->tspr->XPos() >= (w->XSize() * 2 / 3)) && (newx > tx)
       ) ||
      (
       (w->tspr->XPos() >= 0) &&
       (newx - w->tspr->XPos() <= (w->XSize() / 3)) && (newx < tx)
       )
      ) &&
     ((newx) >= (w->XSize() / 3) &&
      (newx) <= (w->tspr->TMapWidth() * TILE_SIZE
		 - w->XSize() / 3))
     ) {
    //    w->tspr->MoveSprite(w->tspr->XPos() + newx - tx,w->tspr->YPos());
    tvx = newx - tx;
  }
  if(
     (
      (
       (w->tspr->YPos() <= (w->tspr->TMapHeight() - 2) * TILE_SIZE
	- w->YSize()) &&
       (newy - w->tspr->YPos() >= (w->YSize() * 2 / 3)) && (newy > ty)
       ) ||
      (
       (w->tspr->YPos() >= 0) &&
       (newy - w->tspr->YPos() <= (w->YSize() / 3)) && (newy < ty)
       )
      ) &&
     ((newy) >= (w->YSize() / 3) &&
      (newy) <= (w->tspr->TMapHeight() * TILE_SIZE
		 - w->YSize() / 3))
     ) {
    //    w->tspr->MoveSprite(w->tspr->XPos(),w->tspr->YPos() + newy - ty);
    tvy = newy - ty;
  }
  w->tspr->SetSpriteMotion(tvx,tvy);
  if(sh) {
    if(GetFlag(ROLLFLAG)) {
      sh->MoveSprite(newx - 24,newy - 24);
    }
    else {
      sh->MoveSprite(newx - 16,newy - 16);
    }
  }
}

void Sonic::RenderSprite(Drawable d) {
  XhedgehogWin *xw = (XhedgehogWin *)host;
  float tempx,tempy;
  tempx = x; tempy = y;
  x -= xw->tspr->XPos();
  y -= xw->tspr->YPos();
  MultiframeSprite::RenderSprite(d);
  x = tempx;
  y = tempy;
}

void Sonic::KeyDown(int k) {
  keys |= k;
  switch(k) {
  case RIGHTKEY:
    if(GetFlag(JUICEFLAG)) {
      break;
    }
    if(!(GetFlag(JUMPFLAG))) {
      if(!GetKeyStatus(LEFTKEY | UPKEY | DOWNKEY)) {
	SetFlag(WALKFLAG);
	if(dir == 0) {
	  accel = 1.0;
	  SetWalkShape();
	}
	else {
	  if(GetFlag(ROLLFLAG)) {
	    accel = 0.2;
	  }
	  else {
	    accel = 1.5;
	    SetSlideShape();
	    SetFlag(SLIDEFLAG);
	  }
	}
      }
    }
    else {
      dir = 0;
      accel = 0.6;
    }
    break;
  case LEFTKEY:
    if(GetFlag(JUICEFLAG)) {
      break;
    }
    if(!(GetFlag(JUMPFLAG))) {
      if(!GetKeyStatus(RIGHTKEY | UPKEY | DOWNKEY)) {
	SetFlag(WALKFLAG);
	if(dir == 1) {	
	  accel = -1.0;
	  SetWalkShape();
	}
	else {
	  if(GetFlag(ROLLFLAG)) {
	    accel = -0.2;
	  }
	  else {
	    accel = -1.5;
	    SetSlideShape();
	    SetFlag(SLIDEFLAG);
	  }
	}
      }
    }
    else {
      dir = 1;
      accel = -0.6;
    }
    break;
  case DOWNKEY:
    if(GetFlag(JUICEFLAG)) {
      break;
    }
    if(GetFlag(ROLLFLAG)) {
      break;
    }
    if(GetFlag(WALKFLAG)) {
      if(vel == 0) {
	SetSquatShape();
      }
      else {
	SetFlag(ROLLFLAG);
	SetSpinShape();
	switch(dir) {
	case 0:
	  accel = -0.2;
	case 1:
	  accel = 0.2;
	}
      }
    }
    break;
  case UPKEY:
    if(GetFlag(JUICEFLAG)) {
      break;
    }
    if(GetFlag(ROLLFLAG)) {
      break;
    }
    if(GetFlag(WALKFLAG)) {
      if(vel == 0) {
	SetLookupShape();
      }
    }
    break;
  case JUMPKEY:
    if(GetFlag(JUMPFLAG)) {
      break;
    }
    if((GetKeyStatus(DOWNKEY) && (vel == 0)) || GetFlag(JUICEFLAG)) {
      SetFlag(JUICEFLAG);
      SetFlag(ROLLFLAG);
      SetJuiceShape();
      break;
    }  
    ClearFlag(WALKFLAG);
    SetFlag(JUMPFLAG);
    SetFlag(ROLLFLAG);
    SetSpinShape();
    ((XhedgehogWin *)host)->SoundSrvPlay(0);
    accel = 0;
    vy = -12;
    break;
  }
}

void Sonic::KeyUp(int k) {
  keys &= (~k);
  switch(k) {
  case RIGHTKEY:
    if(!(GetFlag(JUMPFLAG))) {
      if(!GetFlag(SLIDEFLAG)) {
	accel = -1;
      }
    }
    else
      accel = -0.6;
    break;
  case LEFTKEY:
    if(!(GetFlag(JUMPFLAG))) {
      if(!GetFlag(SLIDEFLAG)) {
	accel = 1;
      }
    }
    else
      accel = 0.6;
    break;
  case DOWNKEY:
    if(GetFlag(JUICEFLAG)) {
      SetFlag(ROLLFLAG);
      ClearFlag(JUICEFLAG);
      SetSpinShape();
      switch(dir) {
      case 0:
	accel = -0.2;
	vel = 20;
	break;
      case 1:
	accel = 0.2;
	vel = -20;
	break;
      }
      break;
    }
    if(GetFlag(WALKFLAG)) {
      if(!GetFlag(ROLLFLAG)) {
	SetStandShape();
      }
    }
    break;
  case UPKEY:
    if(GetFlag(WALKFLAG)) {
      if(!GetFlag(ROLLFLAG)) {
	SetStandShape();
      }
    }
    break;
  }
}
